############################################################################
#
# MapServer Workbench Install
# add program groups & items via dde
# thanks to steve cassidy for the dde code

package require dde

if {[catch {package require Mapscript}]} {
    tk_messageBox -type ok -icon warning \
	-title "MapServer Workbench Installer" -message "Mapscript/Tcl is not\
         installed on your system.\nYou won't be able to use the MapServer\
         Workbench until you also install Mapscript/Tcl.\nSee the README file\
         for more information."
}

proc progman_exec {cmd args} {
    catch {dde exec PROGMAN PROGMAN "\[$cmd ([join $args ,])\]"}
}

proc progman_creategroup { groupname {grouppath ""}} {
    progman_exec CreateGroup $groupname $grouppath
}

# showcmd can be:
#1       Activates and displays the group window. If the window is minimized or
#        maximized, Windows restores it to its original size and position.
#2       Activates the group window and displays it as an icon.
#3       Activates the group window and displays it as a maximized window.
#4       Displays the group window in its most recent size and position. The
#        window that is currently active remains active.
#5       Activates the group window and displays it in its current size and
#        position.
#6       Minimizes the group window.
#7       Displays the group window as an icon. The window that is currently
#        active remains active.
#8       Displays the group window in its current state. The window that is
#        currently active remains active.

proc progman_showgroup { groupname showcmd } {
    progman_exec ShowGroup $groupname $showcmd
}

proc progman_minimizegroup {groupname} {
    progman_showgroup $groupname 6
}

proc progman_deletegroup { groupname } {
    progman_exec DeleteGroup $groupname
}

# additem
# cmdline: full command line of the item
# name: name to appear on the icon
# iconpath: path to an icon for the item
# default_dir: working directory for the program

proc progman_additem { cmdline name iconpath default_dir } {
    progman_exec AddItem $cmdline $name $iconpath 0 0 0 $default_dir
}

proc progman_delitem { name } {
    progman_exec DelItem $name 
}


############################################################################
#
# our code here

cd [file dirname [info script]]

progman_creategroup "MapServer Workbench"
file copy -force -- README README.txt
foreach {prgm name} {README.txt README \
               msappwiz.tcl "MsAppWiz" msedit.tcl "MsEditor" \
               msexplorer.tcl "MsExplorer" msshapex.tcl "MsShapeExlorer"} { 
    progman_delitem $name
    progman_additem [file nativename [file join [pwd] $prgm]] $name "" ""
}

progman_showgroup "\"MapServer Workbench\"" 8

wm title . "MapServer Workbench Installer"
label .l -text "MapServer Workbench has been installed.\n\nPlease read the\
   README file for latest information."

frame .f
button .f.r -text "View README" -command {exec start README.txt &}
button .f.q -text "OK" -command exit

pack .l -side top -padx 30 -pady 20
pack .f -side top
pack .f.r .f.q -side left -padx 15
